#pragma once

class CScene;

class CApplication
{

#pragma region Singleton
private:
	static CApplication * instance;
public:
	static CApplication * GetInstance(void) {
		if (instance == NULL) {
			instance = new CApplication();
		}
		return instance;
	}
#pragma endregion

public:
	void InitWindow(void);
	void InitGL(void);
	void ProcessEvents(void);
	void Cleanup(void);
	double GetTime(void);
	void Redraw(void);
	void Update(void);
	void GameLoop(void);
	void Start(void);

	CScene * CurrentScene;

private:
	CApplication(void);
	~CApplication(void);

};

